<template>
  <div class="mt-5" @contextmenu="showMenu">
    <v-btn rounded :color="formatted_color" @click="toggle" dark>{{
      name
    }}</v-btn>
    <v-menu v-model="menu" :position-x="x" :position-y="y" absolute offset-y>
        <v-color-picker :value="color" @input="$emit('update:color', $event); update();" flat />
    </v-menu>
  </div>
</template>

<script>
export default {
  name: "ChartButton",
  props: ["name", "color", "index"],
  data: () => ({
    enabled: true,
    menu: false,
    x: 0,
    y: 0,
    color: null
  }),
  methods: {
    toggle() {
      this.enabled = !this.enabled;
      this.$emit("toggled", this.index, this.enabled);
    },
    update() {
      this.$emit("updateLabels");
    },
    showMenu(e) {
      e.preventDefault();
      this.menu = false;
      this.x = e.clientX;
      this.y = e.clientY;
      let self = this;
      this.$nextTick(() => {
        self.menu = true;
      });
    },
  },
  computed: {
    formatted_color() {
      return this.enabled ? this.color : "#666666";
    },
  },
};
</script>